Summary: GNU C Compiler
Name: gcc
%define version 2.7.2
Version: %{version}
Release: C2
Copyright: GPL
Group: Development/Languages
Source: ftp://prep.ai.mit.edu/pub/gnu/gcc-%{version}.tar.gz
Source1: gcc-c-skel 
Source2: gcc-c++-skel 
Source3: gcc-objc-skel
Patch1: gcc-2.7.2-make.patch
Patch2: gcc-2.7.2-mips.patch
Patch3: gcc-2.7.2-config-mips.patch
ExclusiveArch: mips
Requires: binutils
Prereq: /sbin/install-info

%changelog

* Thu Apr 2 1998 Gideon Glass <gid@cobaltmicro.com>

 - Fixed the dynamic damn c++ shit (config/mips/linux.h).

* Wed Jan 14 1998 Timothy Stonis <tim@cobaltmicro.com>

 - Added crt, etc.

* Tue Oct 20 1997 Ralf Baechle <ralf@gnu.org>

 - Created GCC package for MIPS based on gcc-2.7.2.3-6.src.rpm.

%description
The GNU C compiler -- a full featured ANSI C compiler, with support
for K&R C as well. GCC provides many levels of source code error
checking tradionaly provided by other tools (such as lint), produces
debugging information, and can perform many different optimizations to
the resulting object code. This contains the back end for C++ and 
Objective C compilers as well.

%package c++
Summary: C++ support for gcc
Group: Development/Languages
Requires: gcc = %{version}

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package objc
Requires: gcc = %{version}
Summary: Objective C support for gcc
Group: Development/Languages

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%prep
%setup -q
%patch1 -p1 -b .rh
%patch2 -p1 -b .nomips
%patch3 -p1 

for n in gcc-c-skel gcc-c++-skel gcc-objc-skel; do
    sed "s/ARCH/`./config.guess | sed 's/unknown-//'`/g" < $RPM_SOURCE_DIR/$n | \
	sed "s/VERSION/${RPM_PACKAGE_VERSION}/g" > $n
done

%build

./configure --prefix=/usr --local-prefix=/usr/local --gxx-include-dir=/usr/include/g++ `./config.guess | sed 's/unknown-//'`

# Uhhh... Just make everything so stage shit... 
#make all

make LANGUAGES=c CFLAGS= LDFLAGS="-s"
make stage1
make CC="stage1/xgcc -Bstage1/" CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s" LANGUAGES=c
make stage2
make CC="stage2/xgcc -Bstage2/" CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s"

# For Objective C only
make objc-runtime CC="stage2/xgcc -Bstage2/" CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s"

%install
rm -f /lib/cpp
rm -f /usr/info/gcc.info* /usr/info/cpp.info*
make CC="stage2/xgcc -Bstage2/" CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s" install

# For Objective C only
make install-libobjc CC="stage2/xgcc -Bstage2/" CFLAGS="$RPM_OPT_FLAGS" LDFLAGS="-s"

#make install
#make install-libobjc


gzip -n -9f /usr/info/gcc.info* /usr/info/cpp.info*

rm -f /usr/bin/cc
ln -sf gcc /usr/bin/cc
ln -sf cccp.1 /usr/man/man1/cpp.1

ln -sf ../usr/lib/gcc-lib/`./config.guess | sed 's/unknown-//'`/${RPM_PACKAGE_VERSION}/cpp /lib/cpp

%post
/sbin/install-info /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/gcc.info.gz /usr/info/dir --entry="* gcc: (gcc).                   The GNU C compiler."
fi
%files -f gcc-c-skel
%doc NEWS PROBLEMS
%dir /usr/lib/gcc-lib
/usr/bin/gcc
/usr/bin/cc
/usr/bin/protoize
/usr/bin/unprotoize

/lib/cpp

/usr/man/man1/cpp.1
/usr/man/man1/cccp.1
/usr/man/man1/gcc.1

/usr/info/cpp.info*
/usr/info/gcc.info*

%files c++ -f gcc-c++-skel

%files objc -f gcc-objc-skel
